#!/usr/bin/python
from __future__ import division
import serial
import syslog
import time
import psutil
import math
import datetime

#The following line is for serial over GPIO
port = '/dev/ttyUSB0'


ard = serial.Serial(port,0,timeout=5)
time.sleep(0.4); # Had to set the baud rate to 0 and then change to 115200 to get the port to reset in ubuntu
ard.close();
#ard.setBaudrate(115200)
ard.baudrate = 115200
ard.open();

time.sleep(2)

print "Start"

try:
    while (True):
        data = "}"
        
        Total = psutil.cpu_percent(interval=0.2)
        Cores = psutil.cpu_percent(interval=0.2, percpu=True)
        MemoryUsed = psutil.virtual_memory().percent
        
        sec = time.mktime(datetime.datetime.now().timetuple()) - psutil.boot_time()
        mins = (sec/60.0)%60.0
        hrs = (sec/3600.0)%24.0
        days = sec/86400.0
        
        uptime = str(int(math.floor(days))) + "D " + str(int(math.floor(hrs))) + "H " + str(int(math.floor(mins))) + "M   "
        
        freedisk = 100.0 - psutil.disk_usage('/').percent #free disk
        
        for x in Cores:
            data = data + chr(int(math.ceil(x))) #CORES
    
        data = data + "|"
        data = data + chr(int(math.ceil(Total)))+"|" #CPU
        data = data + chr(int(math.ceil(MemoryUsed)))+"|" #MEM
        data = data + datetime.datetime.now().strftime("%H:%M") + "|" #TIME
        data = data + datetime.datetime.now().strftime("%Y-%d-%b ").upper() + "|" #DATE
        data = data + uptime + "|" #UT
        data = data + "~"
        ard.flush()
        ard.write(data)
        ard.read()        
finally:
    ard.close()
    
